//Programma.c
#include <stdlib.h>
#include <malloc.h>
#include <stdbool.h>
#include <string.h>
#include "include/list_lib.h"
#include "include/file_lib.h"
#include "include/perceptron_lib.h"
#include "include/main_lib.h"


//max nmber of parameter passed to our program
#define N_ARGUMENTS 8


//default parameter
#define ADABOOST false
#define KERNEL_ALGORITM polinomial
#define POLINOMIAL_DEGREE 2
#define EPOCS 2
#define PATH_TS "Data/Test_set"
#define PATH_TR "Data/Training_set"
#define LOAD_LIST false

bool adaboost= ADABOOST;
t_kernel kernel_algortim= KERNEL_ALGORITM;
unsigned polinomial_degree= POLINOMIAL_DEGREE;
unsigned epocs= EPOCS;
char *test_set = PATH_TS;
char *training_set = PATH_TR;
bool load_list= LOAD_LIST;
char *list = NULL;

int main(int argc ,char *argv[] )
{
	
	bool is_error=false;
	char arguments[N_ARGUMENTS][3]={"-a","-d","-e","-ts","-tr","-l","-k","-h"};
	
	unsigned j,i;


:q
	
	
	//Wrong parameters' number control
	if (!(argc%2) || argc == 1 )
	{
		printf ("Arg. dispari");
		return EXIT_SUCCESS;
	}
	
	//Set variables using program's parameters
	for(i=1;i<argc;i+=2)
	{
		for(j=0;j<N_ARGUMENTS;++j)
		{
			if (!strcmp(argv[i],arguments[j]))
			{
				is_error=false;
				//Set variable
				if (set_variable(arguments[j],argv[i+1]) == EXIT_FAILURE)
				{
					printf("stampo help");
					return EXIT_SUCCESS;	
				}
				break;
			}
			else
				is_error=true;
		}
		
		if (is_error)
		{
			printf("stampo help");
			return EXIT_SUCCESS;
		
		}
	}		
}

int set_variable(const char *argument,const char *value)
{
	
	//Use or not adaboost
	if (!strcmp("-a",argument))
	{
		//don't use
		if (!strcmp("0",value))
		{
			adaboost=false;
			return EXIT_SUCCESS;
			
		}
		//use
		if (!strcmp("1",value))
		{
			adaboost=true;
			return EXIT_SUCCESS;
		}

		return EXIT_FAILURE;
		
	}

	
	if (!strcmp("-e",argument))
	{
	
             if (isalpha(value[0]))
		     return EXIT_FAILURE;
	     else
	     {
		     epocs=atoi(value);
		     return EXIT_SUCCESS;
	     }
		
	}
	//type of kernel argument
	if (!strcmp("-k",argument))
	{
		if(!strcmp("pol",value))
		{
			kernel_algoritm=polinomial;
			return EXIT_SUCCESS;
		}
	
		if(!strcmp("gauss",value))
		{
			kernel_algoritm=gausssian;
			return EXIT_SUCCESS;
		}
		return EXIT_FAILURE;
		
		
	}
	
	//path to list
	if (!strcmp("-l",argument))
	{
		//tell program to load the list next run
		load_list = true;
		
		//copy path from command line arg to our variable
		list = value;
		
	}

}
