//file_lib.h
#ifndef _FILE_LIB_H
#define _FILE_LIB_H 1
#define LINE_FEED 10
#define SPACE 32
#include "./list_lib.h"

struct dimension
{
	unsigned int    n_cols;
	unsigned int    n_rows;
};

//read elements and puts them in a matrix pointed by matrix pointer
int read_file(float ***array_pointer, struct dimension dim,const char *path);

//count line and cols in a file
int line_counter(const char *path,struct dimension *dim);

//Write to specified file list contents and (eventually) remove list from memory
int dump_file(t_list_head *head_pointer,const char *file,bool remove);
#endif
