//voted_list_lib.h
#ifndef _VOTED_LIST_LIB_H
#define _VOTED_LIST_LIB_H 1
#include "./list_lib.h"

struct element_v//structure of the list element
{
	unsigned weight;
	float array[256];
	struct element_v *next;
};
typedef struct element_v v_element  ;

struct list_head_v//structure of the list's head
{
	v_element *first;
	v_element *last;
	t_dimension dimension;
};
typedef struct list_head_v v_list_head ;


struct array_element
{
	unsigned weight;
	float *array;
};
typedef struct array_element v_array_element;

//create a list
int create_list_v(v_list_head  **head_pointer);
//add an element
int add_list_v(v_element elem,v_list_head **head_pointer);
//Put all list's element into an array
int read_list_v(v_array_element **array_pointer,v_list_head *head_pointer);
//free the memory occuped by the list pointed by head
int del_list_v(v_list_head *head);
//create a list from data in a file
int restore_list_v(const char *path,v_list_head **head);
#endif
