//list_lib.h
#ifndef _LIST_LIB_H
#define _LIST_LIB_H 1
typedef unsigned int t_index;
typedef unsigned int t_dimension;

typedef struct list_head //structure of the list's head
{
struct element *first;
struct element *last;
t_dimension dimension;
}t_list_head;

typedef struct element  //structure of the list element
{
t_index index;
struct element *next;
}t_element;

//create a list
int create_list(t_list_head  **head_pointer);
//add an element
int add_list(t_index elem,t_list_head **head_pointer);
//Put all list's element into an array
int read_list(t_index **array_pointer,t_list_head *head_pointer);
//free the memory occuped by the list pointed by head
int del_list(t_list_head *head);
//create a list from data in a file
int restore_list(const char *path,t_list_head **head);
#endif
